## mono 5.18.0.240+dfsg

=== mcs/Makefile ===
thisdir := .

SUBDIRS := build jay mcs class nunit24 ilasm tools tests errors docs packages

# Resgen is corlib specific tool

basic_SUBDIRS := build jay class
build_SUBDIRS := build class class/aot-compiler tools ilasm
monodroid_SUBDIRS := build class tools
monodroid_tools_SUBDIRS := build class tools
monotouch_SUBDIRS := build class tools
monotouch_watch_SUBDIRS := build class
monotouch_tv_SUBDIRS := build class
monotouch_runtime_SUBDIRS := build class
monotouch_watch_runtime_SUBDIRS := build class
monotouch_tv_runtime_SUBDIRS := build class
xammac_SUBDIRS := build class
testing_aot_hybrid_SUBDIRS := build class
testing_aot_full_SUBDIRS := build class
binary_reference_assemblies_SUBDIRS := build class
net_4_x_SUBDIRS := build class nunit24 ilasm tools tests errors docs mcs class/aot-compiler packages
xammac_net_4_5_SUBDIRS := build class
xbuild_12_SUBDIRS := build class tools/xbuild
xbuild_14_SUBDIRS := build class tools/xbuild
winaot_SUBDIRS := build class
orbis_SUBDIRS := build class
unreal_SUBDIRS := build class
wasm_SUBDIRS := build class

include build/rules.make

all-recursive $(STD_TARGETS:=-recursive): dir-check platform-check profile-check

.PHONY: all-local $(STD_TARGETS:=-local)
all-local $(STD_TARGETS:=-local):
	@:

dir-check:
	@if [ "$(NO_DIR_CHECK)" = "" -a "$(PROFILE)" != "basic" ]; then $(MAKE) -C ../runtime; fi

# fun specialty targets

PROFILES = net_4_x binary_reference_assemblies xbuild_12 xbuild_14

.PHONY: all-profiles $(STD_TARGETS:=-profiles)
all-profiles $(STD_TARGETS:=-profiles): %-profiles: profiles-do--%
	@:

profiles-do--%:
	$(if $(PROFILES),$(MAKE) $(PROFILES:%=profile-do--%--$*))

# The % below looks like profile-name--target-name
profile-do--%:
	$(MAKE) PROFILE=$(subst --, ,$*)

# xbuild_12 and xbuild_14 will try to install the same files, so they need
# to be ordered
profile-do--xbuild_14--install: profile-do--xbuild_12--install

# We don't want to run the tests in parallel.  We want behaviour like -k.
profiles-do--run-test:
	ret=:; $(foreach p,$(PROFILES), { $(MAKE) PROFILE=$(p) run-test || ret=false; }; ) $$ret

# Orchestrate the bootstrap here.
_boot_ = all clean install
$(_boot_:%=profile-do--xbuild_14--%):         profile-do--xbuild_14--%:         profile-do--net_4_x--%
$(_boot_:%=profile-do--xbuild_12--%):         profile-do--xbuild_12--%:         profile-do--net_4_x--%
$(_boot_:%=profile-do--binary_reference_assemblies--%):           profile-do--binary_reference_assemblies--%:           profile-do--build--%
$(_boot_:%=profile-do--net_4_x--%):           profile-do--net_4_x--%:           profile-do--build--%
$(_boot_:%=profile-do--monodroid--%):         profile-do--monodroid--%:         profile-do--build--%
$(_boot_:%=profile-do--monodroid_tools--%):         profile-do--monodroid_tools--%:         profile-do--build--%
$(_boot_:%=profile-do--monotouch--%):         profile-do--monotouch--%:         profile-do--build--%
$(_boot_:%=profile-do--monotouch_watch--%):   profile-do--monotouch_watch--%:   profile-do--build--%
$(_boot_:%=profile-do--monotouch_tv--%):      profile-do--monotouch_tv--%:      profile-do--build--%
$(_boot_:%=profile-do--monotouch_runtime--%):  profile-do--monotouch_runtime--%:  profile-do--build--%
$(_boot_:%=profile-do--monotouch_watch_runtime--%):  profile-do--monotouch_watch_runtime--%:  profile-do--build--%
$(_boot_:%=profile-do--monotouch_tv_runtime--%):     profile-do--monotouch_tv_runtime--%:     profile-do--build--%
$(_boot_:%=profile-do--xammac--%):            profile-do--xammac--%:            profile-do--build--%
$(_boot_:%=profile-do--xammac_net_4_5--%):    profile-do--xammac_net_4_5--%:           profile-do--build--%
$(_boot_:%=profile-do--testing_aot_hybrid--%):        profile-do--testing_aot_hybrid--%:        profile-do--build--%
$(_boot_:%=profile-do--testing_aot_full--%):          profile-do--testing_aot_full--%:          profile-do--build--%
$(_boot_:%=profile-do--winaot--%):              profile-do--winaot--%:              profile-do--build--%
$(_boot_:%=profile-do--orbis--%):              profile-do--orbis--%:              profile-do--build--%
$(_boot_:%=profile-do--unreal--%):              profile-do--unreal--%:              profile-do--build--%
$(_boot_:%=profile-do--wasm--%):              profile-do--wasm--%:              profile-do--build--%
$(_boot_:%=profile-do--build--%):             profile-do--build--%:             profile-do--basic--%

testcorlib:
	@cd class/corlib && $(MAKE) test run-test

compiler-tests:
	$(MAKE) TEST_SUBDIRS="tests errors" run-test-profiles

package := mcs-$(VERSION)

DISTFILES = \
	AUTHORS			\
	COPYING			\
	INSTALL.txt		\
	Makefile		\
	mkinstalldirs		\
	MonoIcon.png		\
	README			\
	ScalableMonoIcon.svg

dist-local: dist-default

csproj-local:

dist-pre:
	rm -rf $(package)
	mkdir $(package)

dist-tarball: dist-pre
	$(MAKE) distdir='$(package)' dist-recursive
	tar cvjf $(package).tar.bz2 $(package)

dist: dist-tarball
	rm -rf $(package)

# the egrep -v is kind of a hack (to get rid of the makefrags)
# but otherwise we have to make dist then make clean which
# is sort of not kosher. And it breaks with DIST_ONLY_SUBDIRS.
#
# We need to set prefix on make so class/System/Makefile can find
# the installed System.Xml to build properly

distcheck: dist-tarball
	rm -rf InstallTest Distcheck-MCS ; \
	mkdir InstallTest ; \
	destdir=`cd InstallTest && pwd` ; \
	mv $(package) Distcheck-MCS ; \
	(cd Distcheck-MCS && \
	    $(MAKE) prefix=$(prefix) && $(MAKE) test && $(MAKE) install DESTDIR="$$destdir" && \
	    $(MAKE) clean && $(MAKE) dist || exit 1) || exit 1 ; \
	mv Distcheck-MCS $(package) ; \
	tar tjf $(package)/$(package).tar.bz2 |sed -e 's,/$$,,' |sort >distdist.list ; \
	rm $(package)/$(package).tar.bz2 ; \
	tar tjf $(package).tar.bz2 |sed -e 's,/$$,,' |sort >before.list ; \
	find $(package) |egrep -v '(makefrag|response)' |sed -e 's,/$$,,' |sort >after.list ; \
	cmp before.list after.list || exit 1 ; \
	cmp before.list distdist.list || exit 1 ; \
	rm -f before.list after.list distdist.list ; \
	rm -rf $(package) InstallTest

# Targets for creating API diffs of the framework

MONO_API_SNAPSHOT_PATH := $(topdir)../external/api-snapshot/
GENAPI := $(MONO_API_SNAPSHOT_PATH)tools/genapi/GenAPI.exe
MONO_API_SNAPSHOT_PROFILE_PATH := $(MONO_API_SNAPSHOT_PATH)profiles/$(PROFILE)/
MONO_API_ASSEMBLIES_IGNORED := $(addprefix $(topdir)class/lib/$(PROFILE)/, Mono.CSharp.dll SystemWebTestShim.dll standalone-runner-support.dll nunit.core.dll nunit.core.extensions.dll nunit.core.interfaces.dll nunit.framework.dll nunit.framework.extensions.dll nunit.mocks.dll nunit.util.dll nunit-console-runner.dll nunitlite.dll Mono.Profiler.Log.dll)
MONO_API_ASSEMBLIES := $(filter-out $(MONO_API_ASSEMBLIES_IGNORED), $(wildcard $(topdir)class/lib/$(PROFILE)/*.dll)) $(wildcard $(topdir)class/lib/$(PROFILE)/Facades/*.dll)
MONO_API_ASSEMBLIES_CS := $(MONO_API_ASSEMBLIES:$(topdir)class/lib/$(PROFILE)/%.dll=$(MONO_API_SNAPSHOT_PROFILE_PATH)%.cs)

apidiff/ignored-attr.txt:
	@mkdir -p $(dir $@)
	@echo "T:System.Runtime.CompilerServices.CompilerGeneratedAttribute" > $@

$(MONO_API_SNAPSHOT_PROFILE_PATH)%.cs: $(topdir)class/lib/$(PROFILE)/%.dll $(GENAPI) $(MONO_API_SNAPSHOT_PATH)profiles/license-header.txt apidiff/ignored-attr.txt
	@mkdir -p $(dir $@)
	$(Q) MONO_PATH=$(topdir)class/lib/$(BUILD_TOOLS_PROFILE) $(RUNTIME) $(GENAPI) -libPath:$(topdir)class/lib/$(PROFILE),$(topdir)class/lib/$(PROFILE)/Facades -out:$(dir $@) -headerFile:$(MONO_API_SNAPSHOT_PATH)profiles/license-header.txt -assemblyAttributes -typeForwardedTo -assemblyVersion -excludeAttributesList:apidiff/ignored-attr.txt -assembly:$< || echo "Couldn't process assembly." > $@

mono-api-current: $(MONO_API_ASSEMBLIES_CS)

mono-api-current-clean:
	$(Q) find "$(MONO_API_SNAPSHOT_PROFILE_PATH)" -name "*.cs" -type f -delete

mono-api-diff:
	@echo "Regenerating API snapshot..."
	$(Q) $(MAKE) mono-api-current-clean PROFILE=net_4_x
	$(Q) $(MAKE) mono-api-current-clean PROFILE=monotouch
	$(Q) $(MAKE) mono-api-current-clean PROFILE=monodroid
	$(Q) $(MAKE) mono-api-current PROFILE=net_4_x
	$(Q) $(MAKE) mono-api-current PROFILE=monotouch
	$(Q) $(MAKE) mono-api-current PROFILE=monodroid
	@echo "Checking public API differences..."
	$(Q) cd $(MONO_API_SNAPSHOT_PATH); git add -A .
	$(Q) cd $(MONO_API_SNAPSHOT_PATH); git diff --no-renames HEAD > $(abspath $(topdir))/temp.patch
	@mkdir -p apidiff
	$(Q) sed -e "/@diffdata@/r temp.patch" -e "/@diffdata@/d" -e "s/@title@/Public API Diff/g" -e "s/@description@/If the changes are intentional, run <code>make -C mcs mono-api-diff<\/code> locally and commit changes in external\/api-snapshot./g" diff.html.in > apidiff/index.html
	$(Q) if [ -s temp.patch ]; then echo "Error: Found public API differences, see mcs/apidiff/index.html. If the changes are intentional, please go to external/api-snapshot and commit them."; rm -f temp.patch; exit 1; else echo "No differences found."; rm -f temp.patch; fi

mono-csproj-diff:
	@echo "Generating csproj diff..."
	$(Q) git add -A "*.csproj" $(topdir)../bcl.sln
	$(Q) git diff --no-renames HEAD "*.csproj" $(topdir)../bcl.sln > $(abspath $(topdir))/temp.patch
	@mkdir -p csprojdiff
	$(Q) sed -e "/@diffdata@/r temp.patch" -e "/@diffdata@/d" -e "s/@title@/Project Files Diff/g" -e "s/@description@/Use <code>@monojenkins commit csproj<\/code> to commit them./g" diff.html.in > csprojdiff/index.html
	$(Q) if [ -s temp.patch ]; then echo "Error: Found csproj differences, see mcs/csprojdiff/index.html. If the changes are intentional, please commit them."; rm -f temp.patch; exit 1; else echo "No differences found."; rm -f temp.patch; fi

=== external/api-doc-tools/Makefile ===
MSBUILD = msbuild
CONFIGURATION = Release
BIN = bin/$(CONFIGURATION)
MDOC = $(BIN)/mdoc.exe

all: build

build: $(MDOC)

$(MDOC):
	$(MSBUILD) apidoctools.sln /p:Configuration=$(CONFIGURATION)

prepare:
	git submodule update --init --recursive
	nuget restore apidoctools.sln

clean:
	$(MSBUILD) apidoctools.sln /t:clean
	rm -rf bin/$(CONFIGURATION)

check: build check-monodoc check-mdoc

check-mdoc:
	cd mdoc; $(MAKE) check

check-monodoc:
	cd monodoc; $(MAKE) check

=== external/binary-reference-assemblies/Makefile ===
all:
	$(MAKE) -C v2.0
	$(MAKE) -C v3.5
	$(MAKE) -C v4.0
	$(MAKE) -C v4.5
	$(MAKE) -C v4.5.1
	$(MAKE) -C v4.5.2
	$(MAKE) -C v4.6
	$(MAKE) -C v4.6.1
	$(MAKE) -C v4.6.2
	$(MAKE) -C v4.7
	$(MAKE) -C v4.7.1
	$(MAKE) -C v4.7.2
	$(MAKE) -C mono
	$(MAKE) -C build/monotouch
	$(MAKE) -C build/monodroid

clean:
	$(MAKE) -C v2.0 clean
	$(MAKE) -C v3.5 clean
	$(MAKE) -C v4.0 clean
	$(MAKE) -C v4.5 clean
	$(MAKE) -C v4.5.1 clean
	$(MAKE) -C v4.5.2 clean
	$(MAKE) -C v4.6 clean
	$(MAKE) -C v4.6.1 clean
	$(MAKE) -C v4.6.2 clean
	$(MAKE) -C v4.7 clean
	$(MAKE) -C v4.7.1 clean
	$(MAKE) -C v4.7.2 clean
	$(MAKE) -C mono clean
	$(MAKE) -C build/monotouch clean
	$(MAKE) -C build/monodroid clean

.PHONY: all clean

=== mcs/build/Makefile ===
thisdir = build
SUBDIRS = 
include ../build/rules.make

BUILT_FILES = common/Consts.cs $(topdir)/class/lib/$(PROFILE_DIRECTORY)/Consts.cs

all-local install-local test-local run-test-local csproj-local run-test-ondotnet-local uninstall-local doc-update-local: $(BUILT_FILES)
	@:

clean-local:
	-rm -f $(BUILT_FILES) deps/*

$(topdir)/class/lib/$(PROFILE_DIRECTORY):
	mkdir -p $@

common/Consts.cs $(topdir)/class/lib/$(PROFILE_DIRECTORY)/Consts.cs: common/Consts.cs.in $(wildcard config.make) | $(topdir)/class/lib/$(PROFILE_DIRECTORY)
	test -n '$(MONO_VERSION)'
	test -n '$(MONO_CORLIB_VERSION)'
	sed -e 's,@''MONO_VERSION@,$(MONO_VERSION),' -e 's,@''MONO_CORLIB_VERSION@,$(MONO_CORLIB_VERSION),' $< > $@

PLATFORMS = macos linux win32 unix
PROFILES = \
	basic \
	build \
	binary_reference_assemblies \
	net_4_x \
	xbuild_12 \
	xbuild_14

COMMON_SRCS = \
	Consts.cs.in			\
	Locale.cs			\
	MonoTODOAttribute.cs \
	basic-profile-check.cs		\
	SR.cs	\
	AssemblyRef.cs

DISTFILES = \
	README.makefiles.md		\
	README.platforms		\
	README.configury		\
	config-default.make		\
	corcompare.make			\
	corcompare-api.xsl		\
	executable.make			\
	gensources.cs			\
	library.make			\
	rules.make			\
	tests.make			\
	$(COMMON_SRCS:%=common/%)	\
	$(PLATFORMS:%=platforms/%.make) $(PROFILES:%=profiles/%.make)

dist-local: dist-default

=== mcs/class/Makefile ===
thisdir = class

pcl_facade_dirs := Facades

-include ../build/config.make

ifdef MCS_MODE
MCS_MODE_dirs := Mono.Cecil.Mdb
endif

# The minimal set of csc dependencies
basic_SUBDIRS := \
	Mono.Cecil \
	$(MCS_MODE_dirs) \
	../tools/cil-stringreplacer \
	corlib \
	Mono.Security \
	System \
	System.XML \
	System.Security \
	System.Core \
	System.ComponentModel.Composition.4.5 \
	System.Numerics \
	System.Xml.Linq \
	Mono.CompilerServices.SymbolWriter	\
	PEAPI \
	../ilasm \
	corlib/il

build_SUBDIRS :=  \
	Mono.Cecil \
	$(MCS_MODE_dirs) \
	../tools/cil-stringreplacer \
	corlib \
	Mono.Security \
	System \
	System.XML \
	System.Security \
	Mono.Posix \
	System.Core \
	System.Configuration \
	System.ComponentModel.Composition.4.5 \
	System.Numerics \
	System.Xml.Linq \
	System.IO.Compression \
	System.Drawing			\
	Mono.CompilerServices.SymbolWriter	\
	PEAPI

ifdef MCS_MODE
basic_PARALLEL_SUBDIRS := ../mcs $(pcl_facade_dirs)
build_PARALLEL_SUBDIRS := ../mcs $(pcl_facade_dirs)
else
basic_PARALLEL_SUBDIRS := $(pcl_facade_dirs)
build_PARALLEL_SUBDIRS := $(pcl_facade_dirs)
endif

mobile_common_dirs := \
	corlib	\
	Mono.Security \
	System	\
	System.Core	\
	System.XML	\
	System.Security	\
	I18N		\
	System.ServiceModel.Internals	\
	System.Runtime.Serialization	\
	System.Xml.Linq	\
	System.IdentityModel		\
	System.ServiceModel	\
	System.ServiceModel.Web	\
	System.Json	\
	System.Web.Services	\
	Mono.Data.Tds	\
	System.Transactions	\
	System.Numerics	\
	System.Numerics.Vectors		\
	System.Data	\
	Mono.Data.Sqlite	\
	System.Data.Services.Client \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.DataAnnotations \
	System.ComponentModel.Composition.4.5 \
	System.Net \
	System.Net.Http	\
	System.Windows \
	System.Xml.Serialization \
	Mono.CSharp	\
	Microsoft.CSharp \
	System.Reflection.Context	\
	System.Net.Http.WinHttpHandler \
	System.Runtime.CompilerServices.Unsafe

testing_aot_full_dirs := \
	$(mobile_common_dirs)	\
	Mono.Simd			\
	$(pcl_facade_dirs)

testing_aot_hybrid_dirs := \
	$(mobile_common_dirs)	\
	Mono.Simd			\
	$(pcl_facade_dirs)

xammac_dirs := \
	$(mobile_common_dirs)	\
	Mono.CompilerServices.SymbolWriter	\
	$(pcl_facade_dirs)

monodroid_dirs := \
	$(mobile_common_dirs)	\
	Mono.CompilerServices.SymbolWriter	\
	Mono.Btls.Interface	\
	Mono.Posix	\
	$(pcl_facade_dirs)

monodroid_tools_dirs := \
	Mono.Cecil	\
	ICSharpCode.SharpZipLib	\
	monodoc

monotouch_dirs := \
	$(mobile_common_dirs)	\
	Mono.Simd			\
	$(pcl_facade_dirs)

monotouch_watch_dirs := $(filter-out Mono.Security Mono.Data.Tds,$(monotouch_dirs))
monotouch_tv_dirs   := $(monotouch_dirs)

monotouch_runtime_dirs := \
	corlib \
	Mono.Security \
	System \
	System.Core \
	System.XML \
	Mono.CSharp

monotouch_watch_runtime_dirs := $(filter-out Mono.Security Mono.Data.Tds,$(monotouch_runtime_dirs))
monotouch_tv_runtime_dirs := $(monotouch_runtime_dirs)

winaot_dirs := \
	$(mobile_common_dirs)	\
	System.Drawing			\
	$(pcl_facade_dirs)

unreal_dirs := \
	$(mobile_common_dirs)	\
	System.Drawing			\
	$(pcl_facade_dirs)

wasm_dirs := \
	$(mobile_common_dirs)	\
	System.Drawing			\
	$(pcl_facade_dirs)

xammac_4_5_dirs := \
	corlib	\
	Mono.Security \
	System	\
	System.XML			\
	System.Security			\
	Mono.Posix	\
	System.Core	\
	System.Configuration	\
	I18N		\
	System.ServiceModel.Internals	\
	SMDiagnostics	\
	System.Numerics	\
	System.Numerics.Vectors		\
	Mono.Data.Tds	\
	System.Transactions	\
	System.EnterpriseServices	\
	System.Data	\
	System.Runtime.Serialization	\
	System.Xml.Linq	\
	Mono.Data.Sqlite	\
	System.Runtime.Serialization.Formatters.Soap \
	System.ComponentModel.DataAnnotations \
	System.IdentityModel		\
	System.IdentityModel.Selectors	\
	Mono.Messaging			\
	System.Configuration.Install 	\
	System.Messaging	        \
	System.Web.Services \
	System.ServiceModel	\
	System.ServiceModel.Web	\
	System.Json	\
	System.Data.Services.Client \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.Composition.4.5 \
	System.Net \
	System.Windows \
	System.Xml.Serialization \
	Mono.CSharp	\
	Microsoft.CSharp \
	Mono.CompilerServices.SymbolWriter	\
	System.Data.Linq		\
	System.Net.Http \
	System.Net.Http.WebRequest \
	System.Reflection.Context	\
	System.Net.Http.WinHttpHandler	\
	System.Runtime.CompilerServices.Unsafe \
	$(pcl_facade_dirs)

net_4_x_dirs := \
	corlib				\
	Mono.Security \
	System				\
	System.XML			\
	System.Security			\
	Mono.CompilerServices.SymbolWriter \
	Mono.Posix			\
	System.Core			\
	System.Configuration	\
	System.Drawing			\
	System.IO.Compression 		\
	System.IO.Compression.FileSystem \
	System.Transactions		\
	System.EnterpriseServices	\
	Mono.Data.Tds			\
	System.Numerics		\
	System.Numerics.Vectors		\
	System.Data			\
	System.ComponentModel.DataAnnotations	\
	Accessibility			\
	Mono.WebBrowser			\
	System.Runtime.Serialization.Formatters.Soap \
	System.Windows.Forms		\
	Mono.Data.Sqlite		\
	System.Web.ApplicationServices	\
	Novell.Directory.Ldap		\
	System.DirectoryServices	\
	System.Design			\
	System.Web.Services		\
	System.Web			\
	System.Runtime.Remoting		\
	System.Configuration.Install 	\
	System.Management		\
	System.Data.OracleClient	\
	Cscompmgd			\
	Commons.Xml.Relaxng		\
	Mono.Messaging			\
	System.Messaging	        \
	System.ServiceProcess           \
	System.Drawing.Design		\
	ICSharpCode.SharpZipLib		\
	IBM.Data.DB2			\
	CustomMarshalers		\
	SystemWebTestShim			\
	System.ServiceModel.Internals	\
	SMDiagnostics	\
	System.Runtime.Serialization	\
	System.Xml.Linq			\
	System.Data.Linq		\
	System.Web.Abstractions		\
	System.Web.Routing		\
	System.Runtime.DurableInstancing \
	System.IdentityModel		\
	System.IdentityModel.Selectors	\
	System.ServiceModel		\
	System.Web.Extensions		\
	System.Web.Extensions.Design	\
	System.Web.DynamicData		\
	Mono.CSharp			\
	System.Net			\
	System.Json		\
	Microsoft.CSharp	\
	System.Xaml \
	WindowsBase \
	System.ServiceModel.Activation \
	System.ServiceModel.Routing \
	System.ServiceModel.Discovery \
	System.Runtime.Caching \
	Microsoft.Web.Infrastructure \
	System.ServiceModel.Web \
	System.Net.Http	\
	System.Net.Http.WebRequest \
	System.Web.Razor \
	System.Web.WebPages.Deployment \
	System.Web.WebPages \
	System.Web.WebPages.Razor \
	System.Web.Mvc3 \
	System.Net.Http.Formatting \
	System.Web.Http \
	System.Web.Http.SelfHost \
	System.Web.Http.WebHost

# These are the subdirs which depends on libs in net_4_x_dirs
# or have proper dependencies between each other
net_4_x_parallel_dirs := \
	PEAPI				\
	I18N				\
	Mono.Btls.Interface		\
	Mono.Http			\
	Mono.Cairo                      \
	Mono.Cecil			\
	Mono.Cecil.Mdb			\
	Mono.Debugger.Soft		\
	Mono.C5				\
	Mono.Management			\
	Mono.Options 			\
	Mono.Simd			\
	Mono.Tasklets       		\
	Mono.CodeContracts \
	Mono.Parallel \
	Mono.Security.Win32		\
	Mono.Messaging.RabbitMQ		\
	System.Dynamic			\
	System.Windows.Forms.DataVisualization	\
	System.Reactive.Interfaces \
	System.Reactive.Core \
	System.Reactive.Linq \
	System.Reactive.PlatformServices \
	System.Reactive.Providers \
	System.Reactive.Runtime.Remoting \
	System.Reactive.Windows.Forms \
	System.Reactive.Windows.Threading \
	System.Reactive.Observable.Aliases \
	System.Reactive.Experimental \
	System.Reactive.Debugger \
	System.Data.Services.Client	\
	System.Data.Services \
	System.Data.Entity \
	System.Data.DataSetExtensions	\
	System.Json.Microsoft \
	System.Threading.Tasks.Dataflow \
	System.ComponentModel.Composition.4.5 \
	System.Windows \
	System.Xml.Serialization \
	System.DirectoryServices.Protocols	\
	RabbitMQ.Client			\
	Microsoft.VisualC		\
	WebMatrix.Data \
	monodoc	\
	System.Deployment \
	System.Web.Mobile \
	System.Web.RegularExpressions \
	System.Workflow.Activities \
	System.Workflow.ComponentModel \
	System.Workflow.Runtime \
	System.Reflection.Context \
	Mono.Profiler.Log	\
	Mono.Runtime.Tests	\
	System.Runtime.CompilerServices.Unsafe \
	legacy/Mono.Cecil \
	$(pcl_facade_dirs)

xbuild_2_0_dirs := \
	Microsoft.Build.Framework	\
	Microsoft.Build.Utilities	\
	Microsoft.Build.Engine		\
	Mono.XBuild.Tasks		\
	Microsoft.Build.Tasks

xbuild_4_0_dirs := \
	$(xbuild_2_0_dirs)	\
	Microsoft.Build

orbis_dirs := \
	$(filter-out Microsoft.CSharp Mono.CSharp Mono.Data.Sqlite,$(mobile_common_dirs))	\
	System.Drawing		\
	$(pcl_facade_dirs)

monodroid_SUBDIRS := $(monodroid_dirs)
monodroid_tools_SUBDIRS := $(monodroid_tools_dirs)
monotouch_SUBDIRS := $(monotouch_dirs)
monotouch_watch_SUBDIRS := $(monotouch_watch_dirs)
monotouch_tv_SUBDIRS    := $(monotouch_tv_dirs)
monotouch_runtime_SUBDIRS := $(monotouch_runtime_dirs)
monotouch_watch_runtime_SUBDIRS := $(monotouch_watch_runtime_dirs)
monotouch_tv_runtime_SUBDIRS := $(monotouch_tv_runtime_dirs)
testing_aot_full_SUBDIRS := $(testing_aot_full_dirs)
testing_aot_hybrid_SUBDIRS := $(testing_aot_hybrid_dirs)
xammac_SUBDIRS := $(xammac_dirs)
xammac_net_4_5_SUBDIRS := $(xammac_4_5_dirs)
binary_reference_assemblies_SUBDIRS := reference-assemblies
net_4_x_SUBDIRS := $(net_4_x_dirs) $(xbuild_4_0_dirs)
net_4_x_PARALLEL_SUBDIRS := $(net_4_x_parallel_dirs)
xbuild_12_SUBDIRS := $(xbuild_4_0_dirs)
xbuild_14_SUBDIRS := $(xbuild_4_0_dirs) Microsoft.NuGet.Build.Tasks
winaot_SUBDIRS := $(winaot_dirs)
orbis_SUBDIRS := $(orbis_dirs)
unreal_SUBDIRS := $(unreal_dirs)
wasm_SUBDIRS := $(wasm_dirs)

include ../build/rules.make

SUBDIRS = $(testing_aot_full_dirs) $(testing_aot_hybrid_dirs) $(monotouch_dirs) $(monodroid_dirs) $(monodroid_tools_dirs) $(xammac_dirs) $(net_4_x_dirs) $(net_4_x_parallel_dirs) $(xammac_net_4_5_SUBDIRS) $(unreal_dirs)

DIST_ONLY_SUBDIRS = dlr aot-compiler reference-assemblies $(xbuild_4_0_dirs) Microsoft.NuGet.Build.Tasks

# No new makefiles for: System.Messaging, System.Web.Mobile,
# System.ServiceProcess

DISTFILES = \
	ecma.pub		\
	winfx.pub		\
	winfx3.pub		\
	mono.pub		\
	msfinal.pub		\
	silverlight.pub		\
	reactive.pub		\
	mono.snk		\
	Open.snk		\
	LICENSE 		\
	README			\
	doc/API-notes		\
	doc/NUnitGuidelines	\
	doc/TemplateTest.cs	\
	notes/BitVecto32.txt	\
	MicrosoftAjaxLibrary/License.htm	\
	test-helpers/AdminHelper.cs \
	test-helpers/Configuration.Http.cs \
	test-helpers/NetworkHelpers.cs \
	test-helpers/NunitHelpers.cs \
	test-helpers/PlatformDetection.cs \
	test-helpers/RemoteExecutorTestBase.Mobile.cs \
	test-helpers/RemoteExecutorTestBase.Mono.cs \
	test-helpers/SocketResponder.cs \
	$(foreach HOST_PLATFORM,macos linux win32 unix,lib/$(monolite_dir)/mcs.exe $(monolite_files))

.PHONY: all-local $(STD_TARGETS:=-local)
all-local $(STD_TARGETS:=-local):
	@:

all-local-aot:

monolite_dir = monolite-$(HOST_PLATFORM)/$(MONO_CORLIB_VERSION)

# Files needed to bootstrap C# compiler and cil-stringreplacer
build_files := mscorlib.dll System.dll System.Xml.dll Mono.Security.dll System.Core.dll System.Security.dll System.Configuration.dll \
	System.Numerics.dll System.Xml.Linq.dll System.IO.Compression.dll \
	Facades/System.Collections.Concurrent.dll Facades/System.Linq.dll Facades/System.Runtime.dll Facades/System.Collections.dll	\
	Facades/System.Reflection.Extensions.dll Facades/System.Text.Encoding.Extensions.dll Facades/System.Diagnostics.Debug.dll \
	Facades/System.Reflection.Primitives.dll Facades/System.Text.Encoding.dll Facades/System.Diagnostics.Tools.dll Facades/System.Reflection.dll \
	Facades/System.Threading.Tasks.Parallel.dll Facades/System.Dynamic.Runtime.dll Facades/System.Resources.ResourceManager.dll \
	Facades/System.Threading.Tasks.dll Facades/System.Globalization.dll Facades/System.Runtime.Extensions.dll Facades/System.Threading.dll \
	Facades/System.IO.dll Facades/System.Runtime.InteropServices.dll Facades/System.Xml.ReaderWriter.dll Facades/System.Linq.Expressions.dll \
	Facades/System.Runtime.Numerics.dll Facades/System.Xml.XDocument.dll Facades/System.IO.FileSystem.Primitives.dll Facades/System.IO.FileSystem.dll \
	Facades/System.Diagnostics.FileVersionInfo.dll Facades/System.Security.Cryptography.Primitives.dll Facades/System.Security.Cryptography.Algorithms.dll \

=== mcs/errors/Makefile ===
thisdir = errors
SUBDIRS = 
include ../build/rules.make

DISTFILES = \
	CONTRIBUTORS_README 	\
	errors.txt 		\
	$(wildcard *.cs)	\
	$(wildcard *.il)	\
	$(wildcard *.inc)	\
	$(wildcard *.pub)	\
	$(wildcard *.snk)	\
	$(wildcard *.response)	\
	$(wildcard known-issues-*)	\
	$(wildcard dlls/first/*.cs)	\
	$(wildcard dlls/second/*.cs)

TEST_SUPPORT_FILES = \
	CS0012-lib.dll CS0012-2-lib.dll CS0012-3-lib.dll CS0012-4-lib.dll CS0012-5-lib.dll CS0012-6-lib.dll CS0012-9-lib.dll CS0012-10-lib.dll CS0012-11-lib.dll CS0012-12-lib.dll CS0012-13-lib.dll CS0012-14-lib.dll CS0012-15-lib.dll CS0012-16-lib.dll CS0012-17-lib.dll CS0012-18-lib.dll CS0012-21-lib.dll CS0012-22-lib.dll CS0012-23-lib.dll CS0012-24-lib.dll CS0019-71-lib.dll CS0029-26-lib.dll \
	CS0103-2-lib.dll CS0118-2-lib.dll CS0122-8-lib.dll CS0122-10-lib.dll CS0122-14-lib.dll CS0122-15-lib.dll CS0122-19-lib.dll CS0122-35-lib.dll CS0122-36-lib.dll CS0122-38-lib.dll CS0143-lib.dll CS0144-3-lib.dll CS0165-19-lib.dll CS0165-51-lib.dll \
	CS0205-3-lib.dll CS0246-29-lib.dll CS0229-3-lib.dll CS0229-4-lib.dll CS0266-25-lib.dll \
	CS0315-2-lib.dll \
	CS0425-7-lib.dll CS0433-lib.dll CS0433-2-lib.dll \
	CS0506-3-lib.dll CS0507-7-lib.dll CS0507-8-lib.dll CS0534-3-lib.dll CS0534-4-lib.dll CS0534-6-lib.dll CS0571-3-lib.dll CS0571-5-lib.dll CS0571-6-lib.dll \
	CS0612-2-lib.dll CS0618-2-lib.dll CS0619-8-lib.dll CS0619-17-lib.dll CS0619-32-lib.dll CS0619-33-lib.dll CS0619-36-lib.dll CS0619-42-lib.dll \
	CS0619-43-lib.dll CS1546-lib.dll CS0619-51-lib.dll CS1509-module.dll CS1681-2-lib.dll \
	CS0730-lib.dll CS0731-1-lib.dll CS0731-2-lib.dll \
	CS1070-lib.dll \
	CS1540-15-lib.dll CS1540-17-lib.dll CS1542-lib.dll CS1577-lib.dll \
	CS1683-lib.dll CS1685-2-lib.dll \
	dlls/first/CS1701-lib.dll dlls/second/CS1701-lib.dll CS1701-lib.dll dlls/first/CS1702-lib.dll dlls/second/CS1702-lib.dll CS1702-lib.dll dlls/first/CS1705-lib.dll dlls/second/CS1705-lib.dll CS1705-lib.dll \
	CS2015-lib.dll CS3005-16-lib.dll CS3013-module.dll CSExternAlias-lib.dll \
	CS7069-lib.dll \
	CS8009-lib.dll \
	CSFriendAssembly-lib.dll \
	dlls/first/CS1704-lib.dll \
	dlls/second/CS1704-lib.dll

-include $(mcs_topdir)/build/config.make

# mention all targets
all-local $(STD_TARGETS:=-local):

VALID_PROFILE := $(filter $(DEFAULT_PROFILE), $(PROFILE))
ifdef VALID_PROFILE

qcheck: run-mcs-tests 

# again, run-test is when the tests actually happen, so
# don't compile on make test.

test-local:
	@:

run-test-local: clean-local
	$(MAKE) run-mcs-tests

check: run-test-local

# Required to test parser correctly
# -compiler-options:-v

TEST_PATTERN = 'v4'
TESTER_OPTIONS = -compiler-options:"-v --break-on-ice -d:NET_4_0;NET_4_5"

COMPILER = $(topdir)/class/lib/$(PROFILE)/mcs.exe
TESTER = MONO_RUNTIME='$(RUNTIME)' $(TEST_RUNTIME) $(TEST_RUNTIME_FLAGS) $(LOCAL_RUNTIME_FLAGS) $(topdir)/class/lib/$(PROFILE)/compiler-tester.exe

run-mcs-tests: $(TEST_SUPPORT_FILES)
	$(TESTER) -mode:neg -files:$(TEST_PATTERN) -compiler:$(COMPILER) -issues:known-issues-$(PROFILE) -log:$(PROFILE).log $(TESTER_OPTIONS) $(TOPTIONS)

endif

clean-local:
	rm -f *.exe *.dll *.log *.mdb dummy.xml *.junk dlls/first/*.dll dlls/second/*.dll

dist-local: dist-default

csproj-local install-local uninstall-local:

CS0029-26-lib.dll : CS0029-26-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /publicsign /keyfile:key.snk /out:$@ $<

CS0266-25-lib.dll: CS0266-25-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /r:$(topdir)/class/lib/$(PROFILE)/System.Core.dll /out:$@ $<

dlls/first/CS1701-lib.dll: dlls/first/CS1701-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/first/CS1702-lib.dll: dlls/first/CS1702-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/first/CS1703-lib.dll: dlls/first/CS1703-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/first/CS1705-lib.dll: dlls/first/CS1705-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1701-lib.dll: dlls/second/CS1701-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1702-lib.dll: dlls/second/CS1702-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1703-lib.dll: dlls/second/CS1703-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1705-lib.dll: dlls/second/CS1705-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

CS1701-lib.dll : CS1701-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /r:dlls/first/CS1701-lib.dll /out:$@ $<

CS1702-lib.dll : CS1702-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /r:dlls/first/CS1702-lib.dll /out:$@ $<

CS1705-lib.dll : CS1705-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /r:dlls/first/CS1705-lib.dll /out:$@ $<

CSFriendAssembly-lib.dll : CSFriendAssembly-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /publicsign /keyfile:key.snk /warn:0 /out:$@ $<

%-lib.dll: %-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /out:$@ $<

%-module.dll: %-module.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:module /out:$@ $<

%-lib.dll: %-lib.il
	$(ILASM) /dll /out:$@ $<

=== mcs/ilasm/Makefile ===
thisdir = ilasm
SUBDIRS =
include ../build/rules.make

PROGRAM = ilasm.exe
BUILT_SOURCES = ILParser.cs
LIB_REFS = PEAPI Mono.CompilerServices.SymbolWriter Mono.Security

CLEAN_FILES = parser/y.output

EXTRA_DISTFILES = \
	parser/ILParser.jay	\
	$(wildcard tests/*.il)

ILParser.cs: parser/ILParser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -ct -o $@ $(CURDIR)/$< < $(topdir)/jay/skeleton.cs

include ../build/executable.make

=== mcs/packages/Makefile ===
thisdir = packages
include ../build/rules.make

ROSLYN_CSC_DIR = $(dir $(CSC_LOCATION))

ROSLYN_FILES_FOR_MONO = \
	$(ROSLYN_CSC_DIR)/csc.exe				\
	$(ROSLYN_CSC_DIR)/csc.rsp				\
	$(ROSLYN_CSC_DIR)/csc.exe.config			\
	$(ROSLYN_CSC_DIR)/csi.exe				\
	$(ROSLYN_CSC_DIR)/csi.exe.config			\
	$(ROSLYN_CSC_DIR)/csi.rsp				\
	$(ROSLYN_CSC_DIR)/vbc.exe				\
	$(ROSLYN_CSC_DIR)/vbc.exe.config			\
	$(ROSLYN_CSC_DIR)/vbc.rsp				\
	$(ROSLYN_CSC_DIR)/Microsoft.CodeAnalysis.CSharp.dll	\
	$(ROSLYN_CSC_DIR)/Microsoft.CodeAnalysis.CSharp.Scripting.dll \
	$(ROSLYN_CSC_DIR)/Microsoft.CodeAnalysis.VisualBasic.dll \
	$(ROSLYN_CSC_DIR)/Microsoft.CodeAnalysis.dll		\
	$(ROSLYN_CSC_DIR)/Microsoft.CodeAnalysis.Scripting.dll \
	$(ROSLYN_CSC_DIR)/System.Collections.Immutable.dll	\
	$(ROSLYN_CSC_DIR)/System.Reflection.Metadata.dll	\
	$(ROSLYN_CSC_DIR)/VBCSCompiler.exe			\
	$(ROSLYN_CSC_DIR)/VBCSCompiler.exe.config

ROSLYN_FILES_TO_COPY_FOR_MSBUILD = \
	$(ROSLYN_CSC_DIR)/Microsoft.Build.Tasks.CodeAnalysis.dll \
	$(ROSLYN_CSC_DIR)/Microsoft.CSharp.Core.targets 	 \
	$(ROSLYN_CSC_DIR)/Microsoft.Managed.Core.targets	 \
	$(ROSLYN_CSC_DIR)/Microsoft.VisualBasic.Core.targets

ROSLYN_DIM_FILES = $(topdir)/../external/roslyn-binaries/Prototypes/DefaultInterfaceImplementation/*

DISTFILES = $(ROSLYN_FILES_FOR_MONO) $(ROSLYN_FILES_TO_COPY_FOR_MSBUILD) csi-test.csx

ifeq ($(PROFILE), $(DEFAULT_PROFILE))

TARGET_DIR = $(DESTDIR)$(mono_libdir)/mono/$(FRAMEWORK_VERSION)
MSBUILD_ROSLYN_DIR = $(DESTDIR)$(mono_libdir)/mono/msbuild/15.0/bin/Roslyn

install-local: install-prototypes
	$(MKINSTALLDIRS) $(TARGET_DIR)
	$(INSTALL_LIB) $(ROSLYN_FILES_FOR_MONO) $(TARGET_DIR)
	$(MKINSTALLDIRS) $(MSBUILD_ROSLYN_DIR)
	$(INSTALL_LIB) $(ROSLYN_FILES_TO_COPY_FOR_MSBUILD) $(MSBUILD_ROSLYN_DIR)

	(cd $(MSBUILD_ROSLYN_DIR); for asm in $(ROSLYN_FILES_FOR_MONO); do ln -fs ../../../../$(FRAMEWORK_VERSION)/$$(basename $$asm) . ; done)

install-prototypes:
	$(MKINSTALLDIRS) $(TARGET_DIR)/dim
	$(INSTALL_LIB) $(ROSLYN_DIM_FILES) $(TARGET_DIR)/dim

run-test-local: test-csi

test-csi:
	MONO_PATH="$(topdir)/class/lib/$(PROFILE)" $(RUNTIME) $(ROSLYN_CSC_DIR)/csi.exe csi-test.csx > csi-test-output.txt
	cat csi-test-output.txt && grep -q "hello world" csi-test-output.txt
	rm csi-test-output.txt

endif

dist-local: dist-default

=== mcs/tests/Makefile ===
#
# use make run-test PROFILE=net_2_0
#

thisdir = tests
SUBDIRS =
include ../build/rules.make

DISTFILES = $(wildcard dlls/**/*.cs) $(wildcard dlls/*.cs) $(wildcard dlls/*.inc) $(wildcard dlls/*.il)
DISTFILES += $(wildcard *.cs) $(wildcard *.il) $(wildcard *.xml) $(wildcard *.inc) $(wildcard known-issues-*) $(wildcard *.snk)

with_mono_path = MONO_PATH="$(topdir)/class/lib/$(PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH"

ilasm = $(topdir)/class/lib/$(PROFILE)/ilasm.exe
ILASM = MONO_PATH="$(topdir)/class/lib/$(PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(ilasm)

-include $(mcs_topdir)/build/config.make

USE_MCS_FLAGS :=

# mention all targets
all-local $(STD_TARGETS:=-local):

VALID_PROFILE := $(filter $(DEFAULT_PROFILE), $(PROFILE))
ifdef VALID_PROFILE
# casts
bootstrap-cast.exe: gen-cast-test.cs
	$(BOOT_COMPILE) -target:exe /out:$@ $<

casts.cs: bootstrap-cast.exe
	$(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) $< >$@

casts-mcs.exe: casts.cs
	$(CSCOMPILE) -target:exe /out:$@ $<

casts-boot.exe: casts.cs
	$(BOOT_COMPILE) -target:exe /out:$@ $<

boot-casts.out: casts-boot.exe
	$(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) $< >$@

mcs-casts.out: casts-mcs.exe
	$(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) $< >$@

test-casts: boot-casts.out mcs-casts.out
	cmp $^
	-rm -f bootstrap-cast.exe casts.cs casts-boot.exe casts-mcs.exe boot-casts.out mcs-casts.out

TEST_PATTERN = 'v2'

ifeq (net_4_x, $(PROFILE))
TEST_PATTERN = 'v4'
DEFINES = -compiler-options:"-d:NET_4_0;NET_4_5 -debug"
endif

LOCAL_RUNTIME_FLAGS = --verify-all
COMPILER = $(topdir)/class/lib/$(PROFILE)/mcs.exe
TESTER = MONO_RUNTIME='$(RUNTIME)' $(TEST_RUNTIME) $(TEST_RUNTIME_FLAGS) $(LOCAL_RUNTIME_FLAGS) $(topdir)/class/lib/$(PROFILE)/compiler-tester.exe

TEST_ILS := $(wildcard *-lib.il)

build-compiler-lib:
	cd ../class/Mono.CSharp && $(MAKE) NO_DIR_CHECK=yes

qcheck: build-compiler-lib qcheck2

ifdef TEST_WITH_INTERPRETER
KNOWN_ISSUES = known-issues-interp-$(PROFILE)
else
KNOWN_ISSUES = known-issues-$(PROFILE)
endif

qcheck2:
	$(TESTER) -mode:pos -files:$(TEST_PATTERN) -compiler:$(COMPILER) -issues:$(KNOWN_ISSUES) -log:$(PROFILE).log -il:ver-il-$(PROFILE).xml $(DEFINES) $(TOPTIONS)

gen-mt-tests:
	$(TESTER) -mode:nunit -files:'v2' -compiler:$(COMPILER) -issues:known-issues-mt -compiler-options:"-lib:$(topdir)/class/lib/monotouch projects/MonoTouch/ivt.cs"


TESTERVERBOSE=$(if $(V),-verbose,)

test-local:
	@:

compile-all: $(TEST_ILS:.il=.dll)

run-test-local: compile-all setup qcheck

check: run-test-local

endif

clean-local:
	-rm -fr dir-*
	-rm -f *.exe *.dll *.netmodule *.out *.pdb *.mdb casts.cs *.log
	-rm -f xml-*.xml

dist-local: dist-default
	rm -f $(distdir)/casts.cs

csproj-local:

%-il.dll: %-il.il
	$(ILASM) /dll $<

%-lib.dll: %-lib.il
	$(ILASM) /dll /out:$@ $<

CSCOMPILE_UTIL = $(CSCOMPILE) -noconfig -nologo -r:$(topdir)/class/lib/$(PROFILE)/mscorlib.dll

setup:
	$(CSCOMPILE_UTIL) -t:library dlls/test-679-2/test-679-lib-2.cs -out:dlls/test-679-2/test-679-lib-2.dll
	$(CSCOMPILE_UTIL) -t:library dlls/test-679-1/test-679-lib.cs -r:dlls/test-679-2/test-679-lib-2.dll -out:dlls/test-679-1/test-679-lib.dll
	$(CSCOMPILE_UTIL) -t:library dlls/test-939-common.cs -keyfile:key.snk -publicsign -out:dlls/test-939-common.dll
	$(CSCOMPILE_UTIL) -t:library dlls/test-939-1/test-939-lib.cs -keyfile:key.snk -publicsign -out:dlls/test-939-1/test-939-lib.dll
	$(CSCOMPILE_UTIL) -t:library dlls/test-939-1/test-939-ref.cs -r:dlls/test-939-1/test-939-lib.dll -keyfile:key.snk -publicsign -out:dlls/test-939-1/test-939-ref.dll
	$(CSCOMPILE_UTIL) -t:library dlls/test-939-2/test-939-lib.cs -r:dlls/test-939-common.dll -keyfile:key.snk -publicsign -out:dlls/test-939-2/test-939-lib.dll
	$(ILASM) -dll dlls/test-883.il

=== mcs/tools/Makefile ===
thisdir = tools

net_4_5_dirs := \
	al		\
	linker		\
	culevel		\
	genxs		\
	mkbundle	\
	monop		\
	mono-service	\
	mono-xsd	\
	resgen		\
	wsdl		\
	xbuild		\
	csharp		\
	corcompare	\
	mono-api-diff \
	mono-api-html \
	compiler-tester	\
	mono-xmltool	\
	mono-shlib-cop	\
	sgen		\
	mconfig		\
	installutil	\
	nunitreport	\
	pdb2mdb		\
	sqlsharp	\
	sqlmetal	\
	svcutil		\
	ictool		\
	disco		\
	soapsuds	\
	browsercaps-updater	\
	cil-strip	\
	macpack		\
	dtd2rng		\
	dtd2xsd		\
	mdoc		\
	mod		\
	installvst	\
	lc		\
	mono-configuration-crypto \
	ccrewrite	\
	cccheck		\
	security	\
	mdbrebase	\
	mdb2ppdb	\
	ikdasm		\
	mono-symbolicate	\
	linker-analyzer

build_SUBDIRS = resgen gacutil security culevel cil-stringreplacer commoncryptogenerator resx2sr linker cil-strip corcompare mono-api-diff mono-api-html
monodroid_tools_SUBDIRS = cil-strip linker-analyzer mkbundle mdoc mono-symbolicate
monodroid_SUBDIRS = nunit-lite
monotouch_SUBDIRS = nunit-lite
net_4_5_SUBDIRS = gacutil
net_4_x_SUBDIRS = gacutil
net_4_5_PARALLEL_SUBDIRS = $(net_4_5_dirs)
net_4_x_PARALLEL_SUBDIRS = $(net_4_5_dirs)

SUBDIRS = $(build_SUBDIRS) $(net_4_5_dirs)

include ../build/rules.make

DISTFILES = \
	removecomments.sh

test-local csproj-local run-test-local run-test-ondotnet-local all-local install-local uninstall-local doc-update-local:
	@:

dist-local: dist-default

clean-local:
	rm -f *.exe *.dll *.pdb cormissing.xml

=== mono/btls/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)

project (mono-btls)

if(POLICY CMP0026)
cmake_policy(SET CMP0026 NEW)
endif()
if(POLICY CMP0042)
cmake_policy(SET CMP0042 NEW)
endif()

enable_language(C)
enable_language(CXX)

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

# FIXME: cmake's asm detection is broken when using xcrun.
set (CMAKE_ASM_COMPILER "${CMAKE_C_COMPILER}")
set (CMAKE_ASM_COMPILER_ARG1 "${CMAKE_C_COMPILER_ARG1}")
set (CMAKE_ASM_COMPILER_ID "${CMAKE_C_COMPILER_ID}")
enable_language(ASM)

if (NOT "${BTLS_ARCH}" STREQUAL "")
	message (WARNING "SET ARCH: ${BTLS_ARCH}")
	set (CMAKE_SYSTEM_PROCESSOR "${BTLS_ARCH}")
endif ()

if (NOT MSVC)
	if(${CMAKE_SYSTEM_NAME} MATCHES "AIX" OR ${CMAKE_SYSTEM_NAME} MATCHES "OS400")
		# GCC+XCOFF doesn't support -fvisibility=hidden, and we would prefer XCOFF debugging info.
		set (C_CXX_FLAGS "-Wall -Wsign-compare -Wmissing-field-initializers -fPIC -gxcoff")
	else()
		set (C_CXX_FLAGS "-Wall -Wsign-compare -Wmissing-field-initializers -fPIC -ggdb -fvisibility=hidden")
	endif()
endif ()

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_CXX_FLAGS} ${BTLS_CFLAGS}")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${C_CXX_FLAGS} ${BTLS_CFLAGS}")
set (CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${BTLS_CFLAGS}")
set (CMAKE_MACOSX_RPATH 1)
set (MONO_BTLS 1)

set(BUILD_SHARED_LIBS_SAVED "${BUILD_SHARED_LIBS}")
set(BUILD_SHARED_LIBS OFF)
add_subdirectory (${BTLS_ROOT} boringssl)
set(BUILD_SHARED_LIBS "${BUILD_SHARED_LIBS_SAVED}")

include_directories (
	${SRC_DIR}
	${BTLS_ROOT}/include
)

set (
	MONO_BTLS_SOURCES

	btls-bio.c
	btls-bio.h
	btls-error.c
	btls-error.h
	btls-key.c
	btls-key.h
	btls-pkcs12.c
	btls-pkcs12.h
	btls-ssl-ctx.c
	btls-ssl-ctx.h
	btls-ssl.c
	btls-ssl.h
	btls-time64.c
	btls-util.c
	btls-util.h
	btls-x509-chain.c
	btls-x509-chain.h
	btls-x509-crl.c
	btls-x509-crl.h
	btls-x509-lookup.c
	btls-x509-lookup.h
	btls-x509-lookup-mono.c
	btls-x509-lookup-mono.h
	btls-x509-name.c
	btls-x509-name.h
	btls-x509-revoked.c
	btls-x509-revoked.h
	btls-x509-store-ctx.c
	btls-x509-store-ctx.h
	btls-x509-store.c
	btls-x509-store.h
	btls-x509-verify-param.c
	btls-x509-verify-param.h
	btls-x509.c
	btls-x509.h

	${BORINGSSL_OBJECTS}
)

add_library (mono-btls-shared SHARED ${MONO_BTLS_SOURCES})

=== external/api-doc-tools/mdoc/Makefile ===
CONFIGURATION = Release
PROGRAM = ../bin/$(CONFIGURATION)/mdoc.exe
MONO = mono
CSCOMPILE = mcs
TEST_CSCFLAGS = -target:library

MDOC_COMMON_FLAGS = \
	/resource:../../class/monodoc/Resources/mdoc-html-format.xsl,mdoc-html-format.xsl    \
	/resource:../../class/monodoc/Resources/mdoc-html-utils.xsl,mdoc-html-utils.xsl      \
	/resource:../../class/monodoc/Resources/mdoc-sections-css.xsl,mdoc-sections-css.xsl  \
	/resource:../../class/monodoc/Resources/mono-ecma-css.xsl,mono-ecma-css.xsl          \
	/resource:Resources/defaulttemplate.xsl,defaulttemplate.xsl                 \
	/resource:Resources/monodoc-ecma.xsd,monodoc-ecma.xsd                       \
	/resource:Resources/msitomsx.xsl,msitomsx.xsl                               \
	/resource:Resources/overview.xsl,overview.xsl                               \
	/resource:Resources/stylesheet.xsl,stylesheet.xsl                           \


MONODOC_RESOURCES = \
	../../class/monodoc/Resources/mdoc-html-utils.xsl    \
	../../class/monodoc/Resources/mdoc-sections-css.xsl  \
	../../class/monodoc/Resources/mono-ecma-css.xsl

MDOC_RESOURCES = \
	Resources/defaulttemplate.xsl     \
	Resources/monodoc-ecma.xsd        \
	Resources/msitomsx.xsl            \
	Resources/overview.xsl            \
	Resources/stylesheet.xsl

MDOC_TEST_FILES = \
	Test/CLILibraryTypes.dtd				  \
	Test/DocTest-v1.cs                                        \
	Test/DocTest-v2.patch                                     \
	Test/msxdoc-expected.importslashdoc.xml                   \
	Test/TestEcmaDocs.xml                                     \
	Test/validate.check.monodocer                             \
	Test/validate.check.monodocer.importslashdoc              \
	Test/validate.check.monodocer.since

EXTRA_DISTFILES = \
	$(MDOC_RESOURCES) \
	$(MDOC_TEST_FILES)

MULTI-CLASSIC = Test/DocTest-DropNS-classic.dll Test/DocTest-DropNS-classic-multitest.dll
MULTI-UNIFIED = Test/DocTest-DropNS-unified.dll Test/DocTest-DropNS-unified-multitest.dll

DIFF = diff -rup
DIFF_QUIET = diff --brief
ifeq ($(PLATFORM), win32)
DIFF = diff -rupZ
DIFF_QUIET = diff --brief -Z
endif

cleanup:
	-rm -Rf Test/en.actual Test/html.actual

Test/DocTest-addNonGeneric.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-addNonGeneric.cs

Test/DocTest-addNonGeneric-v2.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-addNonGeneric.cs /define:V2

Test/DocTest-DropNS-classic-secondary.dll:
	@echo $(value @)
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic-secondary.cs

Test/DocTest-DropNS-classic.dll:
	@echo $(value @)
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic.cs

Test/DocTest-DropNS-unified.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-unified.cs

Test/DocTest-DropNS-unified-multitest.dll:
	rm -f $@
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-unified.cs /define:MULTITEST

Test/DocTest-DropNS-classic-multitest.dll:
	rm -f $@
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic.cs /define:MULTITEST

Test/DocTest-DropNS-unified-deletetest.dll:
	rm -f Test/DocTest-DropNS-unified-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-unified.cs /define:DELETETEST

Test/DocTest-DropNS-unified-deletetest-V2.dll:
	rm -f Test/DocTest-DropNS-unified-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:Test/DocTest-DropNS-unified-deletetest.dll Test/DocTest-DropNS-unified.cs /define:DELETETEST,V2

Test/DocTest-DropNS-classic-deletetest.dll:
	rm -f Test/DocTest-DropNS-classic-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic.cs /define:DELETETEST

Test/DocTest-DropNS-classic-deletetest-V2.dll:
	rm -f Test/DocTest-DropNS-classic-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:Test/DocTest-DropNS-classic-deletetest.dll Test/DocTest-DropNS-classic.cs /define:DELETETEST,V2

Test/DocTest.dll: 
	$(CSCOMPILE) $(TEST_CSCFLAGS) -debug -optimize -unsafe -target:library -out:$@ Test/DocTest.cs -r:System.Core.dll -r:Microsoft.CSharp.dll

Test/DocTest-InternalInterface.dll: 
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-InternalInterface.cs

Test/DocTest-framework-inheritance-one.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-framework-inheritance.cs /define:FXONE

Test/DocTest-framework-inheritance-two.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-framework-inheritance.cs /define:FXTWO

Test/DocTest.dll-v1: 
	-rm -f Test/DocTest.cs
	cp Test/DocTest-v1.cs Test/DocTest.cs
	-rm -f Test/DocTest.dll
	$(MAKE) Test/DocTest.dll

Test/DocTest.dll-v2: 
	-rm -f Test/DocTest.cs
	cp Test/DocTest-v1.cs Test/DocTest.cs
	cd Test && patch -p0 < DocTest-v2.patch
	-rm -f Test/DocTest.dll
	$(MAKE) Test/DocTest.dll

Test/DocTest-enumerations.dll: 
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-enumerations.cs

Test/FrameworkTestData: Test/DocTest-addNonGeneric.dll Test/DocTest-DropNS-classic.dll Test/DocTest-DropNS-classic-secondary.dll
	rm -rf Test/FrameworkTestData
	mkdir Test/FrameworkTestData
	mkdir Test/FrameworkTestData/One
	mkdir Test/FrameworkTestData/Two
	cp Test/DocTest-addNonGeneric.dll Test/FrameworkTestData/One/
	cp Test/DocTest-DropNS-classic.dll Test/FrameworkTestData/One/
	cp Test/DocTest-addNonGeneric.dll Test/FrameworkTestData/Two/
	cp Test/DocTest-DropNS-classic-secondary.dll Test/FrameworkTestData/Two/
	$(MONO) $(PROGRAM) fx-bootstrap Test/FrameworkTestData

Test/FrameworkTestData-fx-inheritance: Test/DocTest-framework-inheritance-one.dll Test/DocTest-framework-inheritance-two.dll
	rm -rf Test/FrameworkTestData-fx-inheritance
	mkdir Test/FrameworkTestData-fx-inheritance
	mkdir Test/FrameworkTestData-fx-inheritance/One
	mkdir Test/FrameworkTestData-fx-inheritance/Two
	cp Test/DocTest-framework-inheritance-one.dll Test/FrameworkTestData-fx-inheritance/One/
	cp Test/DocTest-framework-inheritance-two.dll Test/FrameworkTestData-fx-inheritance/Two/
	$(MONO) $(PROGRAM) fx-bootstrap Test/FrameworkTestData-fx-inheritance

check-monodocer-frameworks: Test/FrameworkTestData
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -o Test/en.actual -frameworks Test/FrameworkTestData
	$(DIFF) Test/en.expected-frameworks Test/en.actual

check-monodocer-frameworks-inheritance: Test/FrameworkTestData-fx-inheritance
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -o Test/en.actual -frameworks Test/FrameworkTestData-fx-inheritance
	$(DIFF) Test/en.expected-frameworks-inheritance Test/en.actual

check-monodocer-docid: Test/FrameworkTestData
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -use-docid -o Test/en.actual -frameworks Test/FrameworkTestData
	$(DIFF) Test/en.expected-docid Test/en.actual

check-monodocer-addNonGeneric: 
	-rm -Rf Test/en.actual
	# first, make a docset with the generic method
	$(MAKE) Test/DocTest-addNonGeneric.dll
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual Test/DocTest-addNonGeneric.dll

	# now add a non-generic version of the method and update several times
	$(MAKE) Test/DocTest-addNonGeneric-v2.dll
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual Test/DocTest-addNonGeneric-v2.dll
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual Test/DocTest-addNonGeneric-v2.dll
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual Test/DocTest-addNonGeneric-v2.dll
	$(DIFF) Test/en.expected-addNonGeneric Test/en.actual

check-monodocer-membergroup: Test/DocTest-addNonGeneric-v2.dll Test/DocTest-addNonGeneric.dll
	-rm -Rf Test/en.actual
	cp -r Test/en.expected-membergroup Test/en.actual
	$(MONO) $(PROGRAM) update --debug --exceptions=all -o Test/en.actual Test/DocTest-addNonGeneric-v2.dll
	$(DIFF) Test/en.expected-membergroup Test/en.actual
	$(MONO) $(PROGRAM) validate -f ecma Test/en.actual

check-monodocer-dropns-classic: 
	# tests the simplest --dropns case, a single class where the root namespace was dropped.
	-rm -Rf Test/en.actual
	$(MAKE) Test/DocTest-DropNS-classic.dll
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual Test/DocTest-DropNS-classic.dll --api-style=classic
	$(MAKE) update-monodocer-dropns-unified
	$(DIFF) Test/en.expected-dropns-classic-v1 Test/en.actual

check-monodocer-dropns-multi: 
	-rm -Rf Test/en.actual
	$(MAKE) Test/DocTest-DropNS-classic.dll
	$(MAKE) Test/DocTest-DropNS-unified.dll
	$(MAKE) Test/DocTest-DropNS-classic-multitest.dll
	$(MAKE) Test/DocTest-DropNS-unified-multitest.dll

	# mdoc update for both classic and unified
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual $(MULTI-CLASSIC) --api-style=classic 
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual $(MULTI-UNIFIED) --api-style=unified --dropns Test/DocTest-DropNS-unified.dll=MyFramework --dropns Test/DocTest-DropNS-unified-multitest.dll=MyFramework 
	
	# now run it again to verify idempotency
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual $(MULTI-CLASSIC) --api-style=classic 
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual $(MULTI-UNIFIED) --api-style=unified --dropns Test/DocTest-DropNS-unified.dll=MyFramework --dropns Test/DocTest-DropNS-unified-multitest.dll=MyFramework 
	
	$(DIFF) Test/en.expected-dropns-multi Test/en.actual


check-monodocer-dropns-multi-withexisting: 
	-rm -Rf Test/en.actual
	$(MAKE) Test/DocTest-DropNS-classic.dll
	$(MAKE) Test/DocTest-DropNS-unified.dll
	$(MAKE) Test/DocTest-DropNS-classic-multitest.dll
	$(MAKE) Test/DocTest-DropNS-unified-multitest.dll

	# mdoc update to show a pre-existing set of documents
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual Test/DocTest-DropNS-classic.dll --api-style=classic
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual Test/DocTest-DropNS-unified.dll --api-style=unified --dropns Test/DocTest-DropNS-unified.dll=MyFramework 
	
	# mdoc update for both classic and unified
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual $(MULTI-CLASSIC) --api-style=classic 
	$(MONO) $(PROGRAM) update --exceptions=all -o Test/en.actual $(MULTI-UNIFIED) --api-style=unified --dropns Test/DocTest-DropNS-unified.dll=MyFramework --dropns Test/DocTest-DropNS-unified-multitest.dll=MyFramework 
	
	$(DIFF) Test/en.expected-dropns-multi-withexisting Test/en.actual

check-monodocer-dropns-delete: 
	-rm -Rf Test/en.actual
	rm -Rf Test/DocTest-DropNS-classic-deletetest.dll
	rm -Rf Test/DocTest-DropNS-unified-deletetest.dll
	$(MAKE) Test/DocTest-DropNS-classic-deletetest.dll
	$(MONO) $(PROGRAM) update --delete --exceptions=all -o Test/en.actual Test/DocTest-DropNS-classic-deletetest.dll --api-style=classic
	$(MAKE) Test/DocTest-DropNS-unified-deletetest.dll
	$(MONO) $(PROGRAM) update --delete --exceptions=all -o Test/en.actual Test/DocTest-DropNS-unified-deletetest.dll --api-style=unified --dropns Test/DocTest-DropNS-unified-deletetest.dll=MyFramework
	$(MAKE) Test/DocTest-DropNS-classic-deletetest-V2.dll
	$(MONO) $(PROGRAM) update --delete --exceptions=all -o Test/en.actual Test/DocTest-DropNS-classic-deletetest.dll --api-style=classic
	$(MAKE) Test/DocTest-DropNS-unified-deletetest-V2.dll
	$(MONO) $(PROGRAM) update --delete --exceptions=all -o Test/en.actual Test/DocTest-DropNS-unified-deletetest.dll --api-style=unified --dropns Test/DocTest-DropNS-unified-deletetest.dll=MyFramework
	$(DIFF) Test/en.expected-dropns-delete Test/en.actual

check-monodocer-dropns-classic-withsecondary: 
	# tests case where a secondary assembly is included with a --dropns parameter

=== debian/changelog ===
mono (5.18.0.240+dfsg-5) unstable; urgency=medium

  * [cd49e97] Missed one (Closes: #939923)

 -- Jo Shields <joshield@microsoft.com>  Tue, 10 Sep 2019 09:09:48 -0400

mono (5.18.0.240+dfsg-4) unstable; urgency=medium

  [ Marek Safar ]
  * [d8d5d6b] Fixes __MonoCS__ handling of value types

  [ Jo Shields ]
  * [1e58909] Try python3ification (Closes: #937067)
  * [fb709a0] Python3 in debian/control

 -- Jo Shields <joshield@microsoft.com>  Mon, 09 Sep 2019 14:00:35 -0400

mono (5.18.0.240+dfsg-3) unstable; urgency=high

  [ Jo Shields ]
  * [20a7dd0] Don't build docs on s390x, to work around a dumb issue

  [ Neale Ferguson ]
  * [3713407] Fix s390x Outarg_VT (#10632)
    * Fix outarg_vt processing. Fixes #10549
    * Cleanup unused bits and pieces
    * Correct the handling of structures being retuned from a call
    * Restore vtcopy code etc.
    (Closes: #921232)

 -- Jo Shields <joshield@microsoft.com>  Tue, 16 Apr 2019 15:41:50 -0400

mono (5.18.0.240+dfsg-2) unstable; urgency=medium

  * [fcb8084] Add missing libmono-system-native (Closes: #920531)
  * [8b705cf] Don't call cert-sync if it doesn't exist (Closes: #902663)
  * [0514d12] Try fixing kFreeBSD building

 -- Jo Shields <directhex@apebox.org>  Sat, 26 Jan 2019 13:19:06 -0500

mono (5.18.0.240+dfsg-1) unstable; urgency=medium

  [ Jo Shields ]
  * [c67387f] New upstream version 5.18.0.240+dfsg
  * [7a3d16f] Add reference-assemblies-with-csc patch for v4.7.2
  * [5d42c62] Reorder rules so it's possible to override CFLAGS/CXXFLAGS 
    per-arch
  * [c1147ec] Let's not worry about LLVM for now
  * [d6ff03e] Don't override GCC to 5.5 on s390x
  * [e0fb8de] Enable BTLS on ppc64el
  * [c842d23] Use provided mono-api-diff.exe
  * [f262b7e] Install v4.7.2 API
  * [871c1b3] Refreshed symbols
  * [89d55c3] Use langversion 7.2 for tests (7.3 needs Roslyn)
  * [ae548db] Disallow directory traversal (Closes: CVE-2018-1002208)
  * [de5aae0] Switch internal dh_clideps to use ikdasm
  * [b518c84] Add v4.7.2 API to dh_clideps excludes
  * [be0afd7] -fstack-protector-strong breaks s390x on PIC-default gcc. 
    Remove it there. (Closes: #919371)
  * [73b4472] Refreshed clilibs

  [ Neale Ferguson ]
  * [753ee8c] Fix s390x build broken by incorrect specification of the 
    msgfi instuc… (#10026)
    Fix s390x build broken by incorrect specification of the msgfi
    instruction used in MUL_IMM type operations. The instruction had 
    been encoded as its 32-bit counterpart (msfi).
    In addition, the s390x microcode makes the 
    mono_strength_reduction_division unnecessary so this can be bypassed.
    The change to basic.make is just to avoid error messages when 
    basic-profile-check.exe hasn't been built yet.
  * [cb37e0b] Simplify retrieving TLS offset
  * [fecfbf8] Cater for later glibc use of ucontext
  * [cc78fc2] Missing include

 -- Jo Shields <joshield@microsoft.com>  Fri, 18 Jan 2019 12:18:02 -0500

mono (5.16.0.220+dfsg3-2) unstable; urgency=medium

  * No-change rebuild (Closes: #919031)

 -- Jo Shields <directhex@apebox.org>  Sat, 12 Jan 2019 15:01:30 -0500

=== debian/control ===
Source: mono
Section: cli-mono
Priority: optional
Maintainer: Debian Mono Group <pkg-mono-group@lists.alioth.debian.org>
Uploaders: Mirco Bauer <meebey@debian.org>, Jo Shields <directhex@apebox.org>
Build-Depends: debhelper (>= 7),
	dpkg-dev (>= 1.16.1~),
	procps,
	python3,
	bison,
	libtool,
	libxml-dom-perl,
	libxslt1-dev,
	dc,
	lsb-release,
	libx11-dev,
	libxt-dev,
	tzdata,
	cmake,
	zlib1g-dev,
	autoconf,
	automake
Standards-Version: 3.9.6
Homepage: http://www.mono-project.com/
Vcs-Git: https://salsa.debian.org/dotnet-team/mono.git
Vcs-Browser: https://salsa.debian.org/dotnet-team/mono

Package: mono-runtime-common
Provides: cli-runtime, cli-virtual-machine
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: mono-common (<< 2.4), mono-jit (<< 2.4), libmono0 (<< 2.4), mono-runtime (<< 3.2.1)
Conflicts: mono-common (<< 2.4),
           mono-jit (<< 2.4),
           mono-1.0-runtime (<< 2.4),
           mono-2.0-runtime (<< 2.4),
           mono-runtime (<< 3.2.1)
Suggests: xdg-utils | libgnome2-0 | konqueror
Recommends: binfmt-support (>= 1.1.2)
Depends: ${shlibs:Depends},
         ${misc:Depends},
         binutils,
         mono-gac (= ${source:Version})
Description: Mono runtime - common files
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains common files for the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono".
 "mono" executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures. Optionally this package configures BINFMT support.

Package: mono-runtime
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-runtime-sgen (= ${binary:Version})
Description: Mono runtime - default version
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package installs this architecture's default runtime version.

Package: mono-runtime-sgen
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-runtime-common (= ${binary:Version})
Homepage: http://www.mono-project.com/Compacting_GC
Description: Mono runtime - SGen
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses SGen which is Mono's new simple generational garbage
 collector.

Package: mono-runtime-boehm
Architecture: amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-runtime-common (= ${binary:Version})
Description: Mono runtime - Boehm
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses Boehm's conservative garbage collector.

Package: mono-runtime-dbg
Priority: optional
Section: debug
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: mono-jit-dbg (<< 2.4)
Conflicts: mono-jit-dbg (<< 2.4)
Depends: ${misc:Depends}, mono-runtime-sgen (= ${binary:Version}), mono-runtime-boehm (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x]
Recommends: gdb
Description: Mono runtime, debugging symbols
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the debugging symbols of the Mono JIT/AOT compiler.

Package: mono-utils
Provides: cil-disassembler
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: mono-mcs (<= 1.1.6-4)
Depends: ${shlibs:Depends}, ${misc:Depends}, libmonoboehm-2.0-1 (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x],
 libmono-corlib4.5-cil (= ${source:Version})
Description: Mono utilities
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package includes various tools useful for CLI developers, like
 pedump, monodis and monograph.

Package: ca-certificates-mono
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${cli:Depends}, ca-certificates (>= 20121114)
Description: Common CA certificates (Mono keystore)
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package uses the hooks of the ca-certificates package to update the
 Mono keystore.

Package: mono-complete
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends},
         mono-runtime (= ${binary:Version}),
         mono-runtime-sgen (= ${binary:Version}),
         libmono-2.0-1 (= ${binary:Version}),
         libmono-profiler (= ${binary:Version}),
         mono-utils (= ${binary:Version}),
         mono-jay (= ${binary:Version}),
         mono-devel (= ${source:Version}),
         mono-mcs (= ${source:Version}),
         mono-csharp-shell (= ${source:Version}),
         mono-4.0-gac (= ${source:Version}),
         mono-4.0-service (= ${source:Version}),
         monodoc-base (= ${source:Version}),
         monodoc-manual (= ${source:Version}),
         libmono-cil-dev (= ${source:Version}),
         ca-certificates-mono (= ${source:Version})
Description: complete Mono runtime, development tools and all libraries
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This is a metapackage and pulls in the Mono runtime, development tools and
 all libraries.
 .
 Install this package if you want to run software for Mono or Microsoft .NET
 which you are not installing from a Debian package.
 .
 For packagers: This package is not to be used as dependency for packages!
 You should build-depend on cli-common-dev and the needed libraries instead.

Package: libmono-2.0-1
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: libmono-dev (<= 1.1.6-4)
Conflicts: mono-utils (<< 1.2.3.1-4)
Depends: ${shlibs:Depends}, ${misc:Depends}, libmonosgen-2.0-1 (= ${binary:Version})
Description: Mono JIT library (Default version)
 Shared library for Mono, used for embedding/hosting of the JIT.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmono-2.0-dev
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, libmonosgen-2.0-dev (= ${binary:Version})
Description: Mono JIT library - Development files (Default version)
 Header files and static libraries for libmono-2.0.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmonosgen-2.0-1
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mono JIT library (SGen GC)
 Shared library for Mono, used for embedding/hosting of the JIT.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmonosgen-2.0-1-dbg
Priority: optional
Section: debug
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, libmonosgen-2.0-1 (= ${binary:Version})
Recommends: gdb
Description: Mono JIT library, debugging symbols (SGen GC)
 This package contains the debugging symbols of the Mono JIT library.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmonosgen-2.0-dev
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include debian/mono-archs.make

# Assume Debian behaviour by default.
DISTRO = $(shell lsb_release -si)

MAKEFILE = $(firstword $(MAKEFILE_LIST))
DEBIAN_DIR = $(dir $(MAKEFILE))
SOURCE_DIR = $(DEBIAN_DIR)/..

VERSION = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Vers | cut -d\  -f2)
UPVERSION = $(shell echo $(VERSION) | sed 's,-.*,,' | sed 's,+dfsg.*,,')
UPVERSION_THREEPART = $(shell echo $(UPVERSION) | cut -f1-3 -d.)
NEXT_UPVERSION = $(shell perl -e '$$_=pop; s/(\d+)$$/$$1+1/e; print' $(UPVERSION))
DEB_SOURCE_NAME = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Source | cut -d" " -f2)

RUN_MONO = LD_LIBRARY_PATH=debian/tmp/usr/lib MONO_PATH=debian/tmp/usr/lib/mono/4.5 debian/tmp/usr/bin/mono
KILL_MONO = pgrep mono | xargs kill -9
DH_INTERNAL_MONO_PARAM = --internal-mono
ifeq ($(shell dpkg --compare-versions $$(dpkg-query -f '$${Version}' -W debhelper) lt 7.1; echo $$?), 0)
	DH_INTERNAL_MONO_PARAM = internal-mono
endif

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	CONF_FLAGS += --build $(DEB_HOST_GNU_TYPE)
else
	CONF_FLAGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	CONF_FLAGS += --enable-minimal=aot
endif

ifeq ($(DEB_HOST_ARCH), armel)
	CONF_FLAGS += --with-fpu=NONE --with-tls=pthread
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), armhf)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), i386)
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), amd64)
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), mipsel)
	CONF_FLAGS += --with-tls=pthread
endif

ifeq ($(DEB_HOST_ARCH), powerpc)
	CONF_FLAGS += --with-tls=pthread
endif

ifeq ($(DEB_HOST_ARCH), ppc64)
	CONF_FLAGS += --with-tls=pthread
endif

ifeq ($(DEB_HOST_ARCH), ppc64el)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), s390x)
        CONF_FLAGS += --with-mcs-docs=no
	BTLS_ARCH = true
	CFLAGS:=$(filter-out -fstack-protector-strong,$(CFLAGS))
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),$(DEB_MONO_SGEN_ARCHS)))
	CONF_FLAGS += --with-sgen=yes
else
	CONF_FLAGS += --with-sgen=no
endif

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	MINI_TEST = true
	MONO_BOEHM_TEST = true
	MONO_SGEN_TEST = true
else
	TIMEOUT = timeout -k 1h 1h
	MINI_TEST = cd mono/mini && $(TIMEOUT) make check; $(KILL_MONO)
	MONO_BOEHM_TEST = cd mono/tests && MONO_ENV_OPTIONS=--gc=boehm $(TIMEOUT) make check; $(KILL_MONO)
	MONO_SGEN_TEST = cd mono/tests && MONO_ENV_OPTIONS=--gc=sgen $(TIMEOUT) make check; $(KILL_MONO)
endif

ifeq ($(DEB_HOST_ARCH), arm64)
	MONO_BOEHM_TEST = true
	CONF_FLAGS += --disable-boehm
	SKIP_LIBGC = true
	BTLS_ARCH = true
endif


CONFIGURE =	CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)"   \
		$(GCC) ./configure $(CONF_FLAGS) --prefix=/usr \
		  --mandir=\$${prefix}/share/man \
		  --infodir=\$${prefix}/share/info --sysconfdir=/etc \
		  --with-ikvm-native=no \
		  --disable-quiet-build \
		  --with-csc=mcs \
		  --disable-system-aot \
		  --enable-llvm=no \
		  --enable-loadedllvm=no

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	EGLIB_MAKE_FLAGS += -j$(NUMJOBS)
	LIBGC_MAKE_FLAGS += -j$(NUMJOBS)
	MONO_MAKE_FLAGS += -j$(NUMJOBS)
endif

source: source-stamp
source-stamp:
	cd $(DEBIAN_DIR) && tar cJf mono-source.tar.xz --exclude=mono-source.tar.xz -C ../.. $$(cd ..; basename $$(pwd))
	touch $@

autoreconf: autoreconf-stamp
autoreconf-stamp: source-stamp
	autoreconf -f -i -s
	touch $@

configure: configure-stamp
configure-stamp: autoreconf-stamp
	dh_testdir
	$(CONFIGURE)
	touch $@

build: build-stamp
build-indep: build-stamp
build-arch: build-stamp
build-stamp: configure-stamp
	dh_testdir
	cd mono/eglib && $(MAKE) $(EGLIB_MAKE_FLAGS)
ifndef SKIP_LIBGC
	cd libgc && $(MAKE) $(LIBGC_MAKE_FLAGS)
endif
	cd mono && $(MAKE) $(MONO_MAKE_FLAGS)
	LC_ALL=C $(MAKE) $(MAKE_FLAGS) EXTERNAL_MCS=false EXTERNAL_MONO=false

	cd debian/detector && \
	  $(MAKE)
	chmod +x debian/dh_makeclilibs \
	         debian/dh_clideps \
	         debian/dh_clistrip \
	         debian/dh_clifixperms \
	         debian/dh_monoaot

	cp -a ./external/binary-reference-assemblies/v4.7.1 ./external/binary-reference-assemblies/v4.7.1.debbak
	find ./external/binary-reference-assemblies/v4.7.1/ -name \*.dll -print -delete
	cd ./external/binary-reference-assemblies/ && MONO_PATH=$(CURDIR)/mcs/class/lib/net_4_x-linux/ V=1 CSC="$(CURDIR)/runtime/mono-wrapper $(CURDIR)/mcs/class/lib/net_4_x-linux/mcs.exe" make

	touch $@

test: test-stamp
test-stamp: build-stamp
	-$(MINI_TEST)
	-$(MONO_BOEHM_TEST)
	-$(MONO_SGEN_TEST)
	-$(KILL_MONO)
	# funny bug-459094.cs creates too long directory names which
	# pbuilder is unable to remove, eh
	rm -rf mono/tests/abcde12345abcde12345abcde12345abcde12345/
	touch $@

clean:
	echo "distro is $(DISTRO)"
	dh_testdir
	dh_testroot
ifneq ("$(wildcard external/binary-reference-assemblies/v4.7.1.debbak)","")
		rm -rf external/binary-reference-assemblies/v4.7.1
		mv external/binary-reference-assemblies/v4.7.1.debbak external/binary-reference-assemblies/v4.7.1
endif
	[ ! -f Makefile ] || $(MAKE) distclean
	# distclean misses stuff
	find -name "*.mdb" -delete
	find ./external/binary-reference-assemblies/ -name "*.dll" -not -path "./external/binary-reference-assemblies/v4.7.1/*" -print -delete
	rm -rf mcs/class/lib/basic/ \
	       mcs/class/lib/net_4_5/

	-cd debian/detector && $(MAKE) clean
	rm -f debian/MonoGetAssemblyName.exe

	# clean stuff handled by autoreconf
	rm -rf configure config.sub config.guess aclocal.m4 autom4te.cache/
	find . -name "Makefile.in" -delete

	rm -f mcs/packages/*.dll mcs/packages/*.exe* mcs/packages/*.rsp
	rm -f autoreconf-stamp
	rm -f configure-*-stamp
	rm -f build-*-stamp
	rm -f install-*-stamp

	dh_clean

install: install-stamp
install-stamp:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	cd mcs/jay && \
		$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

	# don't want docs of bundled libgc
	rm -rf debian/tmp/usr/share/libgc-mono
	# Mono.Security.Win32.dll is only useful on windows, as it wrap the win api
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/Mono.Security.Win32/
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/Mono.Security.Win32.dll*
	# we don't ship bundled nunit of mono
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/nunit*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/pkgconfig/mono-nunit.pc
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/nunit*/
	rm -f  $(CURDIR)/debian/tmp/usr/bin/nunit*

	# mono 2.10.1 bug, prj2make was removed but the start script not
	rm -f $(CURDIR)/debian/tmp/usr/bin/prj2make

	# copy missing 2.0 manpages
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/al.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/al2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mcs.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/gmcs.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mcs.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/dmcs.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mono-service.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/mono-service2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/wsdl.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/wsdl2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/gacutil.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/gacutil2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/monop.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/monop2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/resgen.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/resgen2.1
	touch $@
